function ImproPlot()
nDim = 10;
% Function name
fName = ' - Ackley 10D';
% BLUE code
DFP = 'Var1.0_DFP_Ackley10DProgress_0.csv';
% RED code
DSCG = 'Var1.0_DSCG_Ackley10DProgress_0.csv';
% Notes
% Col 1 = actual fitness
% Col 2 = average improvement
% Col 3 = average evaluations
% Col 4 = average improvement rate
col = 3;
titlelabels = {'Actual Fitness', 'Expected Fitness Improvement',...
            'Expected Number of Evaluations',...
            'Expected Fitness Improvement Rate'};
Yaxis = {'Fitness', 'Expected FI', 'Expected N', 'Expected FIR'};
Xaxis = 'Sorted fitness of local optima';
figure(1);
hold all
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%       Draw line of DFP methods
A = dlmread(DFP,',',2, nDim);
[temp IDX]=  sort(A(:,1));
D = A(IDX,:);

% % Plot actual fitness
% subplot(311);
% plot(D(:,1),'-.k');
% title([titlelabels{1} fName]);
% xlabel(Xaxis);
% Plot improvement
subplot(211);
plot(D(:,1),D(:,col),'.b');
hold on
plot([0 max(D(:,1))], [0 0],'--c');
title([titlelabels{col} fName]);
xlabel(Xaxis);
legend('DFP');
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%       Clear memory
clear A D;
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%       Draw line of DSCG methods
A = dlmread(DSCG,',',2, nDim);
[temp IDX]=  sort(A(:,1));
D = A(IDX,:);

% Plot improvement
subplot(212);
plot(D(:,1), D(:,col),'.r');
hold on
plot([0 max(D(:,1))], [0 0],'--c');
xlabel(Xaxis);
legend('DSCG');

saveas(1, [Yaxis{col} fName], 'fig');
end