function [pFDC kFDC] = FDCAnalysis()
dirName = 'DFP/Ackley';
funcName= 'Ackley';
nDim = '10D';
nRun = 30;
kFDC = zeros(1,nRun);
pFDC = zeros(1,nRun);
for i=1:nRun
    fileName = strcat(dirName,'/','DFP_',funcName, nDim, 'Local_',num2str(i-1),'.csv');
%     fileName = strcat(dirName,'/','DFP_',funcName, nDim, '_',num2str(i-1),'.csv');
    fprintf('Processing %s\n',fileName);
    A = loadLocalP(fileName);
    DF = getDF(A);
    %Kendall correlation
    kendall = corr(DF,'type','Kendall');
    kFDC(1,i) = kendall(1,2);
    %Pearson correlation
    pearson = corr(DF,'type','Pearson');
    pFDC(1,i) = pearson(1,2);
    fprintf('Pearson/Kendall FDC = %f/%f\n', pFDC(1,i), kFDC(1,i));
    %Scatter plot
    scatter(DF(:,1), DF(:,2),'r.');
    hold on
end
% Summary of FDC
avgPear = mean(pFDC); stdPear = std(pFDC);
avgKen = mean(kFDC); stdKen = std(kFDC);
fprintf('Pearson FDC = %f %f\n', avgPear, stdPear);
fprintf('Kendall FDC = %f %f\n', avgKen, stdKen);
fprintf('LaTeX = %f & %f & %f & %f \\\\ \n', avgPear, stdPear, avgKen, stdKen);
% Save figure file
fig_title = ['Fitness-distance scatter plot of ' funcName '-' nDim];
fprintf('%s\n',fig_title);
h = title(fig_title);
xlabel('Distance');
ylabel('Fitness');
saveas(h,strcat('Scatter-',funcName,'-',nDim,'.fig'));
%saveas(h,strcat('Scatter-',funcName,'-',nDim,'.bmp'))
fprintf('Figure saved!\n');
end
