function [pFDC kFDC] = calCorr(DF)
[N col] = size(DF);
%Number of iterations
R = 30;
nSamples = 4000;
pFDC = zeros(1,R);
kFDC = zeros(1,R);
for i = 1:R
    fprintf('At iteration %d \n',i);
    rIndex = floor(rand(1,nSamples)*N + 1);
    samples = DF(rIndex,:);
    %Kendall correlation
    kendall = corr(samples,'type','Kendall');
    kFDC(1,i) = kendall(1,2);
    %Pearson correlation
    pearson = corr(samples,'type','Pearson');
    pFDC(1,i) = pearson(1,2);
end
scatter(DF(:,1), DF(:,2),'.');
title('Fitness-distance scatter plot of Griewank 10D');
xlabel('Distance');
ylabel('Fitness');
end