function [L] = mergeLocal(dirName, funcName, nDim)
%dirName = 'DFP/Weierstrass';
%funcName= 'Weierstrass';
%nDim = '2D';
method = 'DFP';
nRun = 30;
format long
data = cell(1,nRun);
for i=1:nRun
    fileName = strcat(dirName,'/',method,'_',funcName, nDim, 'Local_',num2str(i-1),'.csv');
    fprintf('Processing %s\n',fileName);
    A = loadLocalP(fileName);
    data{i} = sortLocalP(A);
end
L = data{1};
for i = 2:nRun
    fprintf('Combining to file %d \n',i);
    L = sortLocalTwo(L, data{i});
end
recordName = strcat(dirName,'/',method,'_',funcName,'_', nDim, '.csv');
dlmwrite(recordName,L,'delimiter',',','precision',16);
end
