package mytest.evaluation.real;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import mytest.evaluation.*;

/**
 * Implementation of Water Modelling RMS function. <p></p>
 * @author Le Minh Nghia, NTU-Singapore
 */
public class WaterProblem extends FitnessFunction {
	String dirName = "";
	public String getName() {return "Water Problem";}
	public WaterProblem(long initCount, String dir) {
		super(initCount);
		dirName = dir;
	}

	public double calculate(double[] inputs) {
		// increase number of evaluations
		String fileName = "output" + NUM_EVAL+ ".txt";
		double res = 0;
		// output input vector to file
		outputAParam(inputs);
		
		// wait for evaluation result
		File dir = new File(dirName);
		File file;
		do 
		{
			file = new File(dir, "otok" + NUM_EVAL+ ".txt");
		} 
		while(!file.exists());
		
		String s = null;

			
		try {
			FileReader fr = new FileReader(dirName + fileName);
			BufferedReader input = new BufferedReader(fr);
			
			s = input.readLine();
			fr.close();
			if (s != null) {
					res = Double.parseDouble(s);
			}
			else {
				System.out.println("NUL NUL NUL");
			}
			/* read the return evaluation */
			// System.out.println("Evaluated " + NUM_EVAL + ": " + s + ", " +  res);
		} catch(IOException e) {
			System.err.println(e.getMessage());
		}
		
		return res;
	}
	public void outputAParam(double[] inputs) {
		long count = NUM_EVAL;
		/* prepare log file */
    	PrintStream MyOutput = null;
    	try {
    	       MyOutput = new PrintStream(new FileOutputStream(dirName + 
    	    		   "input" + (count-1) +".txt"));
    	} catch(Exception e) {}
    	int nDim = inputs.length;
    	for (int i = 0; i < nDim; i++)
    		if (i == nDim - 1)
    			MyOutput.print(inputs[i] + "\n");
    		else
    			MyOutput.print(inputs[i] + " ");
    	MyOutput.close();
    	/* Rename to input%counter%.txt */
    	File oldFile = new File(dirName + "input" + (count-1) +".txt");
    	File newFile = new File(dirName + "input" + count+".txt");
    	boolean success = oldFile.renameTo(newFile);
    	if (!success) {
    		System.err.println("IO Error - Can not rename the file");
    		System.exit(0);
    	}
    	/* Rename to to%counter%.txt */
    	if (count == 1) {
    		try {
     	       MyOutput = new PrintStream(new FileOutputStream(dirName + 
     	    		   "itok" + count +".txt"));
     	       MyOutput.close();
    		} catch(Exception e) {}
    	}
    	else 
    	{
    		oldFile = new File(dirName + "itok" + (count-1) + ".txt");
    		newFile = new File(dirName + "itok" + count + ".txt");
    		success = oldFile.renameTo(newFile);
    		if (!success) {
    			System.err.println("IO Error - Can not rename the file");
    			System.exit(0);
    		}
    	}
	}
}
