package optimization.dataprocess;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 * To extract best fitness found from record of fitness evaluations
 * @author Le Minh Nghia, NTU-Singapore
 *
 */
public class BestFitness {

	
	/* absolute path */
	static public String dirName = "C:/Water/";
	static public String fileName = "Water-SRS-eval-0.csv";
	
	public static void main(String[] args) {
		try {
			FileReader fr = new FileReader(dirName + fileName);
			BufferedReader input = new BufferedReader(fr);
			/* Output to file */
			PrintStream outputStream= null;
			outputStream = new PrintStream(
					new FileOutputStream(dirName + "bestFound.csv"));
			String s = "";
			double fitness = 0, bestFound = Double.MAX_VALUE;
			System.out.println("Start extracting...");
			do {
					s = input.readLine();
					if (s != null) {
						fitness = Double.parseDouble(s);
						if (le(fitness,bestFound))
							bestFound = fitness;
						outputStream.println(bestFound);
						outputStream.flush();
					}
			} while (s!= null);
			fr.close();
			outputStream.close();
			System.out.println("Finish extracting...");
		} catch(IOException e) {
			System.err.println(e.getMessage());
			System.exit(0);
		}
	}
	/**
	 * Less or equal to x <=y
	 */
	public static boolean le(double x, double y) 
	{
		boolean res = false;
		if ((y - x) > (Math.abs(x)*(-1E-9)))
			res= true;
		return res;
	}
}
