package optimization.dataprocess;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 * Extract only chromosome solutions from archived population 
 * @author Le Minh Nghia, NTU-Singapore
 *
 */
public class PopExtraction {

	/* absolute path */
	static public String dirName = "C:/Research/Codes/Optinformatics/yale/Sphere/pop";
	/* should change to proper pop size */
	static public int dim;
	static double threshold = Double.MAX_VALUE;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
			File dir = new File(dirName);
			if (dir.exists()) {
				File [] files = dir.listFiles();
				System.out.println("Start extracting individual set...");
				PrintStream outputStream= null;
				outputStream = new PrintStream(
						new FileOutputStream(dirName + "/../popset" +
								"T-" + threshold +".csv"));
				boolean write = false;
				for (int i = 0; i < files.length; i++) {
					FileReader fr = new FileReader(files[i]);
					BufferedReader input = new BufferedReader(fr);
					String s = "";
					/* Pass 2 first lines */
					s = input.readLine();
					s = input.readLine();
					dim = Integer.parseInt(s);
					if (!write) {
						outputStream.println("0");
						outputStream.println(dim);
						write = true;
					}
					do {
						s = input.readLine();
						if (s != null) {
							String [] params = s.split(",");
							double t = Double.parseDouble(params[dim]);
							/* Extract rules pass conditions */ 
							if (le(t, threshold)) {
								outputStream.println(s);
							}
							
							/* This part is not RESTRICTED  
							if (le(t, 1.1178)) {
								outputStream.println(s + ", High");
							}
							if (le(11.3722,t)) {
								outputStream.println(s + ", Low");
							}
							*/
						}
					} 
					while (s != null);
					fr.close();
				}
				outputStream.close();
				System.out.println("Finish extracting individual set...");
			}
			else {
				System.out.println("Directory does not exist!");
			}
		} catch(IOException e) {
			System.err.println(e.getMessage());
			System.exit(0);
		}
	}
	/**
	 * Less or equal to x <=y
	 */
	public static boolean le(double x, double y) 
	{
		boolean res = false;
		if ((y - x) > (Math.abs(x)*(-1E-9)))
			res= true;
		return res;
	}
}
