package optimization.dataprocess;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
/**
 * Extract vector of fitness from a population archived to file
 * @author Le Minh Nghia, NTU-Singapore
 *
 */
public class PopFitness {
	/* absolute path */
	static public String dirName = "C:/Water/";
	static public String fileName = "Water-LEM-eval-0.csv";
	/* should change to proper pop size */
	static public int popSize = 200;
	public static void main(String [] args) {
		try {
			FileReader fr = new FileReader(dirName + fileName);
			BufferedReader input = new BufferedReader(fr);
			String s = "";
			double [] popFitness = new double[popSize];
			int index = 0, iter = -1; 
			double fitness = 0;
			System.out.println("Start extracting...");
			do {
					s = input.readLine();
					if (s != null) {
						fitness = Double.parseDouble(s);
						popFitness[index++] = fitness;
						/* reach one population */
						if (index == popSize) {
							iter++;
							/* Output to file */
							PrintStream outputStream= null;
							outputStream = new PrintStream(
									new FileOutputStream(dirName + "popFit/pFit" + iter + ".csv"));
							for (int i = 0; i < popSize; i++)
								outputStream.println(popFitness[i]);
							outputStream.close();
							/* Reset */
							index = 0;
						}
					}
			} while (s!= null);
			fr.close();
			System.out.println("Finish extracting...");
		} catch(IOException e) {
			System.err.println(e.getMessage());
			System.exit(0);
		}
	}
}
