package optimization.dataprocess;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 * Extract rules in [][] format to csv format for visualization
 * @author Le Minh Nghia, NTU-Singapore
 *
 */
public class RuleExtraction {

	/* absolute path */
	static public String dirName = "C:/Water/rules";
	/* should change to proper pop size */
	static public int dim;
	static double threshold = 0.02;
	static double confidence = 0.6;
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		double T=1, C= 1, N = 1;
		try {
			File dir = new File(dirName);
			if (dir.exists()) {
				File [] files = dir.listFiles();
				System.out.println("Start extracting rules...");
				PrintStream outputStream= null;
				outputStream = new PrintStream(
						new FileOutputStream(dirName + "/../ruleset" +
								"T-" + threshold + "C-" + confidence +".csv"));
				PrintStream patternStream = null;
				patternStream = new PrintStream(
						new FileOutputStream(dirName + "/../rulepattern" +
								"T-" + threshold + "C-" + confidence +".csv"));
				for (int i = 0; i < files.length; i++) {
					FileReader fr = new FileReader(files[i]);
					BufferedReader input = new BufferedReader(fr);
					String s = "";
					/* Pass 2 first lines */
					s = input.readLine();
					s = input.readLine();
					do {
						s = input.readLine();
						if (s != null) {
							String [] contents = s.split("\\|");
							/* Extract threshold & parameters */
							String [] params = contents[1].split(",");
							
							if (params.length == 3) {
								T = Double.parseDouble(params[0]);
								C = Double.parseDouble(params[1]);
								N = Double.parseDouble(params[2]);
							}
							else 
							{
								System.out.println("Something wrongs!");
								System.exit(0);
							}
							/* Extract rules pass conditions */
							if (le(T, threshold) && le(confidence, (C-N)/C)) {
								outputStream.println(i + ", " + contents[1] + 
										", " + contents[2] + "," + contents[3]);
								patternStream.println(i + ", " + contents[4]);
								outputStream.flush();
								patternStream.flush();
							}
						}
					} 
					while (s != null);
					fr.close();
				}
				outputStream.close();
				System.out.println("Finish extracting rules...");
			}
			else {
				System.out.println("Directory does not exist!");
			}
		} catch(IOException e) {
			System.err.println(e.getMessage());
			System.exit(0);
		}
	}
	/**
	 * Less or equal to (x <= y)
	 */
	public static boolean le(double x, double y) 
	{
		boolean res = false;
		if ((y - x) > (Math.abs(x)*(-1E-9)))
			res= true;
		return res;
	}
}
